| IDA SDK

Functions
Local types information and manipulation helpers

## Detailed Description

## Functions
idaman tid_t ida_export | get_named_type_tid (const char *name)
| Get named local type TID. More...
idaman bool ida_export | get_tid_name (qstring *out, tid_t tid)
| Get a type name for the specified TID. More...
idaman uint32 ida_export | get_tid_ordinal (tid_t tid)
| Get type ordinal number for TID. More...
idaman ssize_t ida_export | get_udm_by_fullname (udm_t *udm, const char *fullname)
| Get udt member by full name. More...
idaman bool ida_export | get_idainfo_by_udm (flags64_t *flags, opinfo_t *ti, const udm_t &udm, ea_t refinfo_ea=BADADDR)
| Calculate IDA info from udt member. More...
tid_t | create_enum_type (const char *enum_name, enum_type_data_t &ei, int enum_width, type_sign_t sign, bool convert_to_bitmask, const char *enum_cmt=nullptr)
| Create type enum. More...
tid_t | edm_t::get_tid () const

## Function Documentation

## ◆ get_named_type_tid()

idaman tid_t ida_export get_named_type_tid | ( | const char * | name | ) |

Get named local type TID.

Parameters

  name | type name

Returns
  TID or BADADDR

## ◆ get_tid_name()

idaman bool ida_export get_tid_name | ( | qstring * | out,
|  | tid_t | tid
| ) |  |

Get a type name for the specified TID.

Parameters

  | tid | type TID
  [out] | out | type name

Returns
  true if there is type with TID

Note
  this function is the inverse to get_named_type_tid

## ◆ get_tid_ordinal()

idaman uint32 ida_export get_tid_ordinal | ( | tid_t | tid | ) |

Get type ordinal number for TID.

Parameters

  tid | type/enum constant/udt member TID

Returns
  type ordinal number or 0

## ◆ get_udm_by_fullname()

idaman ssize_t ida_export get_udm_by_fullname | ( | udm_t * | udm,
|  | const char * | fullname
| ) |  |

Get udt member by full name.

Parameters

  [out] | udm | member, can be NULL
  | fullname | udt member name in format <udt name>.<member name>

Returns
  member index into udt_type_data_t or -1

## ◆ get_idainfo_by_udm()

idaman bool ida_export get_idainfo_by_udm | ( | flags64_t * | flags,
|  | opinfo_t * | ti,
|  | const udm_t & | udm,
|  | ea_t | refinfo_ea = `BADADDR`
| ) |  |

Calculate IDA info from udt member.

Parameters

  flags[out] | flags (see bytes.hpp) for udt member
  ti[out] | additional representation information, see set_opinfo()
  udm | udt member
  refinfo_ea | if specified will be used to adjust the refinfo_t data

Note
  any output argument may be nullptr

## ◆ create_enum_type()

tid_t create_enum_type | ( | const char * | enum_name,
|  | enum_type_data_t & | ei,
|  | int | enum_width,
|  | type_sign_t | sign,
|  | bool | convert_to_bitmask,
|  | const char * | enum_cmt = `nullptr`
| ) |  |
| inline

Create type enum.

Parameters

  enum_name | type name
  ei | enum type data
  enum_width | the width of an enum element allowed values: 0 (unspecified),1,2,4,8,16,32,64
  sign | enum sign
  convert_to_bitmask | try convert enum to bitmask enum
  enum_cmt | enum type comment

Returns
  enum TID